# Simple Random Stock

Randomly select a stock from your favorite U.S index and have them saved in your history for future uses. 
I created this application as a side project. I wanted to accomplish what I thought was impossible. I'm interested in the finance field. I wasn't able to find an app that would randomly select a stock for my style. Thus, I created this app.

<img align="left" src="/readmeimages/index-tab.png" width="300" height="600">
<img align="left" src="/readmeimages/stock-tab.png" width="300" height="600">
<img src="/readmeimages/history-tab.png" width="300" height="600">

<br>

[![Build Status](https://travis-ci.org/joemccann/dillinger.svg?branch=master)](https://travis-ci.org/joemccann/dillinger)

## Mobile applications

Operating System | Download |
-----------------|----------|
Android          | <a href='https://play.google.com/store/apps/details?id=com.willchan.simple_random_stock'><img alt='Get it on Google Play' height="40px" src='https://joplinapp.org/images/BadgeAndroid.png'></a>


### Technologies

Simple Random stock uses a number of open source projects to work properly:

  - [Room Database] - Use SQLite to cache your app's data locally
  - [Lifecycles] - to perform certain actions in response to a component's lifecycle
  - [MaterialIO] - The Web equivalent of Bootstrap for Mobile
  - [Unsplash] - image by Ankush Minda on Unsplash 
  - [Gradle] - build tool for obtaining dependencies
  - [Dillinger] - open source tool to create this README.md

### Launch

- No minimum hardware requirments
- Have Android Studios
- Fork or clone a copy of this repo and allow gradle to handle the build process
- Click 'run' on SplashScreen located in the package .../splashscreens/SplashScreenActivity and the app will load

### Development

Want to contribute? Great! Submit a pull request

### Test

There are tests written in Junit and Espresso.

### Todos

 - Write MORE Tests
 - Add Night Mode
 - Maybe come up with a way to run the app originally on MainActivity, instead of SplashScreenActivity

License
----

MIT

[//]: # (These are reference links used in the body of this note and get stripped out when the markdown processor does its job. There is no need to format nicely because it shouldn't be seen. Thanks SO - http://stackoverflow.com/questions/4823468/store-comments-in-markdown-syntax)

   [Unsplash]: <https://unsplash.com/photos/VcD5OD2jDGA>
   [Dillinger]: <https://dillinger.io/>
   [Gradle]: <https://gradle.org/install/>
   [MaterialIO]: <https://material.io/>
   [Lifecycles]: <https://developer.android.com/topic/libraries/architecture/lifecycle#:~:text=If%20a%20library%20provides%20classes%20that%20need%20to,on%20the%20client%20side.%20Implementing%20a%20custom%20LifecycleOwner>
   [Room Database]: <https://developer.android.com/topic/libraries/architecture/room#:~:text=Room%20Persistence%20Library%20Part%20of%20Android%20Jetpack.%20The,data%20on%20a%20device%20that%27s%20running%20your%20app.>

